<section class="partial">
    <section>
        <h2>&#x1F3AE; Puzzler &#x1F3AE;</h2>
        <pre style="font-size: 0.6em;"><code>
  const readFile = require('fs').readFile;

  readFile(__filename, () => {
    setTimeout(() => console.log('=> setTimeout'), 0);
    setImmediate(() => console.log('=> setImmediate'));
    process.nextTick(() => console.log('=> nextTick'));
  });
        </code></pre>
        <ol>
            <li class="very-small">setTimeout, setImmediate, nextTick</li>
            <li class="very-small">nextTick, setImmediate, setTimeout</li>
            <li class="very-small">setImmediate, nextTick, setTimeout</li>
            <li class="very-small">Encore un autre</li>
        </ol>
    </section>

    <section>
        <h2>&#x1F300; Event Loop &#x1F300;</h2>
        <ul>
            <li class="fragment very-small"><strong>timers</strong> : exécute les callbacks <code>setTimeout</code>/<code>setInterval</code> enregistrés</li>
            <li class="fragment very-small"><strong>I/O callbacks</strong> : exécute tous les callbacks sauf close, timers et <code>setImmediate</code></li>
            <li class="fragment very-small"><strong>idle, prepare</strong> : interne</li>
            <li class="fragment very-small"><strong>poll</strong> : récupération ou attente de nouveaux évènements I/O</li>
            <li class="fragment very-small"><strong>check</strong> : exécute les callbacks <code>setImmediate</code> enregistrés</li>
            <li class="fragment very-small"><strong>close callbacks</strong> : <code>socket.on('close', ...)</code></li>
            <li class="fragment very-small">
                <strong>nextTickQueue</strong> (<img src="../img/warning.png" class="icon" />) :
                hors event-loop et immédiatement après l'opération en cours (affamé)
            </li>
        </ul>
        <aside class="notes">
            Exemple : setTimeout() de 100ms, posé dans la pile et en attente.<br>
            Puis lecture d'un fichier qui met 95ms (I/O).<br>
            Succès donc cycle avec exécution du résultat et de son callback de 10ms.<br>
            Enfin le seuil du setTimeout est atteint donc cycle pour aller dans la pahe timers.<br>
            Total : 105ms ! Donc comprendre pas avant 100ms.
        </aside>
    </section>

    <section>
        <h2>&#x1F3AE; Puzzler &#x1F3AE;</h2>
        <pre style="font-size: 0.6em;"><code>
  const readFile = require('fs').readFile;

  readFile(__filename, () => {
    setTimeout(() => console.log('=> setTimeout'), 0);
    setImmediate(() => console.log('=> setImmediate'));
    process.nextTick(() => console.log('=> nextTick'));
  });
        </code></pre>
        <ol>
            <li class="very-small">setTimeout, setImmediate, nextTick</li>
            <li class="very-small"><strong>nextTick, setImmediate, setTimeout</strong></li>
            <li class="very-small">setImmediate, nextTick, setTimeout</li>
            <li class="very-small">Encore un autre</li>
        </ol>
        <aside class="notes">
            Car nextTick immédiatement après la fin de la fonction.<br>
            Donc on peut affamé très rapidement l'event-loop si on en abuse !<br>
            setImmediate appelé après la phase de poll (nouveaux évènements).<br>
            Enfin nouveau cycle et les timers en premier (aussi pour setInterval).
        </aside>
    </section>

    <section>
        <h2>&#x1F3AE; Puzzler Bonus&#x1F3AE;</h2>
        <br>
        <pre style="font-size: 0.6em;"><code>
  setTimeout(() => console.log('=> setTimeout'), 0);
  setImmediate(() => console.log('=> setImmediate'));
  process.nextTick(() => console.log('=> nextTick'));
        </code></pre>
        <div class="fragment">
            <pre><code class="ascii">
  => nextTick
  => setTimeout (dès fois)
  => setImmediate (dès fois)
            </code></pre>
            <div>Non déterministe !</div>
        </div>
    </section>
</section>
